$(document).ready(function () {

    /* input textfield with placeholder */
    $('#SearchTerm').focus(function () {
        var input_txt = $('#SearchTerm').val();
        if (input_txt == "Search This Library") {
            $('#SearchTerm').val('');
            $('#SearchTerm').removeClass('input_placeholder');
        }
    });

    $('#SearchTerm').blur(function () {
        var input_txt = $('#SearchTerm').val();
        if (input_txt == '') {
            $('#SearchTerm').val("Search This Library");
            $('#SearchTerm').addClass('input_placeholder');
        }
    });

    $('.btn_search').click(function () {
        submit_search();
    });

    if (disableSearch) {
        $('#search_form input').attr('disabled', 'disabled');
    }

    if (disablePDF) {
        $('#pdf_button').attr('disabled', 'disabled').addClass('grayout').css("cursor", "auto");
    }

    if (noPDF) {
        $('#pdf_button').css("display", "none");
    }

    if (noUpdate) {
        $('.info_updatedate').css("display", "none");
    }

    if (noProdVer) {
        $('.prodversion').css("display", "none");
    }

    if (noLangMenu) {
        $('.langPane').css("display", "none");
    }

    var widthSpan = $('#dummy_span');
    var btn_width = widthSpan.text("Feedback").width();
    if (btn_width + 10 > 64) {
        $('#feedback_button').css("width", btn_width + 10);
    }
    btn_width = widthSpan.text("Print View").width();
    if (btn_width + 10 > 64) {
        $('#printview_button').css("width", btn_width + 10);
    }
    widthSpan.css("display", "none");

    $('#btn_openLayer').click(function () {
        if ($('#SearchLayer').hasClass('hidden')) {
            $('#SearchLayer').addClass('showed').removeClass('hidden');
        } else {
            $('#SearchLayer').addClass('hidden').removeClass('showed');
        }
    });

    titleText = new TitleText($('#mkh_doctitle'));

    window.onresize = resizeWindow;
    resizeWindow();

    $('.btn_openNav4').click(function () {
        $('.topicPane_home').show(100);
        $('.grayoutLayer').show();
        $('.btn_closeNav4').show(100);
        $('.btn_openNav4').hide();
    });

    $('.btn_closeNav4').click(function () {
        $('.topicPane_home').hide(100);
        $('.grayoutLayer').hide();
        $('.btn_closeNav4').hide();
        $('.btn_openNav4').show();
    });

    $('.grayoutLayer').click(function () {
        $('.topicPane_home').hide(100);
        $('.grayoutLayer').hide();
        $('.btn_closeNav4').hide();
        $('.btn_openNav4').show();
    });


    $('#SearchLayer').click(function () {
        $(this).addClass('hidden').removeClass('showed');
    });

    $('ul.topicList li').click(function (event) {
        $('ul.topicList li').removeClass("topic_selected");
        $(this).addClass("topic_selected");

        if ($(this).hasClass("lv4")) {
            return;
        }

        if ($(event.target).is("li")) {
            if ($(this).hasClass("expanded")) {
                $(this).next("ul").hide();
            } else {
                $(this).next("ul").show();
            }
            $(this).toggleClass("expanded");
            $(this).addClass("topic_selected");
        }
    });

    $('#pdf_button').click(function () {
        var pn = $('div#partnumber').text();
        var url = "../../pdf/" + pn + ".pdf";
        window.open(url);
    });

    $('#printview_button').click(function () {
        setActiveStyleSheet('print');
    });

    $('#feedback_button').click(function () {
        if (legacyFeedback) {
            gotoURL("http://www.oracle.com/goto/docfeedback");
        } else {
            call_survey();
        }
    });

    $('#download_button').click(function () {
        libraryDownload();
    });

});

function TitleText(titleElm) {
    this.elms = new Array();
    this.workingElms = new Array();
    this.widths = new Array();
    this.workingWidths = new Array();
    this.titleString = titleElm.text();
    this.shorten = false;
    var method = 0;
    var lang = $('meta[name="language"]').attr('content');
    if (lang == 'ja' || lang == 'ko' || lang == 'zh' || lang == 'zh_TW') {
        method = 1;
    }

    if (method == 0) {
        // assume words are separated by space
        var str = "";
        var words = this.titleString.split(' ');
        for (var i = 0; i < words.length; i++) {
            if (str.length > 0) {
                str += " " + (words[i]);
            } else {
                str = words[i];
            }
            this.elms.push(str);
            titleElm.text(str);
            this.widths.push(titleElm.width());
        }
    } else {
        // Asian languages
        var str = "";
        for (var i = 0; i < this.titleString.length; i++) {
            str += this.titleString.charAt(i);
            this.elms.push(str);
            titleElm.text(str);
            this.widths.push(titleElm.width());
        }
    }

    this.width = function () {
        return this.workingWidths[this.workingWidths.length - 1];
    }

    this.next = function () {
        this.shorten = true;
        this.workingElms.pop();
        this.workingWidths.pop();
        return this.width();
    }

    this.toString = function () {
        if (this.shorten) {
            return this.workingElms[this.workingElms.length - 1] + " ...";
        }
        return this.titleString;
    }

    this.reset = function () {
        this.workingElms = this.elms.slice();
        this.workingWidths = this.widths.slice();
        this.shorten = false;
    }
}

function resizeWindow() {
    titleText.reset();
    var titleSpan = $('#mkh_doctitle');
    var titleDiv = $('#mkh_div_doctitle');
    var width = titleDiv.width();
    var ttlWidth = titleText.width();
    if (width < (ttlWidth + 10)) {
        for (; ; ) {
            var newWidth = titleText.next();
            if (width < 100 || width >= (newWidth + 10)) {
                break;
            }
        }
    }
    titleSpan.html(titleText.toString());

    /* imedia query for Navigation Panel display */
    $(window).resize(function () {
        var pageWidth = $(window).width();
        if (pageWidth > 981) {
            $('.topicPane_home').show();
            $('.grayoutLayer').show();
        } else {
            $('.topicPane_home').hide();
            $('.grayoutLayer').hide();
            $('.btn_closeNav4').hide();
            $('.btn_openNav4').show();
        }
    });
}

function submit_search() {
    var form = document.getElementById("search_form");
    var q = document.getElementById("q");
    var product = document.getElementById("product");
    var language = document.getElementById("language");
    var lib = $("#librarynumber").text();
    var path = "docs/cd/" + lib;

    var search_term = $("#SearchTerm").val();

    if (search_term == "") {
        alert("Search field is empty");
        return false;
    }

    q.value = search_term;
    // q.value = search_term + " url:/" + path;

    // changed 5/23/17 to trigger osearch based on osearch_type
    if(search_type == "offline_search") {
        form.action = "search.html";
    } else {
        product.value = lib + "_01";
        language.value = document.documentElement.getAttribute("lang");
        form.action = "http://docs.oracle.com/apps/search/search.jsp";
  //  form.action = "http://search.oracle.com/search/search";
        
    }
    
    form.method = "get";
    form.target = "_top";
    form.submit();
}

function libraryDownload() {
    var libpn = $('div#librarynumber').text();
    var url = "http://docs.oracle.com/cds/" + libpn + "_01.zip";
    if (libpn.match("^E19")) {          //only for migrated libraries
        url = "http://docs.oracle.com/cds/" + libpn + "-01.zip";
    }
    window.open(url);
}

function gotoURL(url) {
    window.location.href = url;
}
